// memtest.cpp : Defines the entry point for the DLL application.
//

#include "memtestDLL.h"
#include "LinkedList.h"
#ifdef MEMTEST_STATIC
#include "sprtf.h"
#else
#define  sprtf sprtflist
#endif

// This is an example of an exported variable
MEMTEST_API int nMemtest = 0;

PVOID pmtVoid1 = 0;
PVOID pmtVoid2 = 0;
PVOID pmtVoid3 = 0;
PVOID pmtVoid4 = 0;
PVOID pmtVoid5 = 0;

#ifdef USE_LINKED_LIST
LE sLineList = { &sLineList, &sLineList };
#else // !USE_LINKED_LIST
static char szDllBuf[1024] = { "\0" };
static size_t BufLen = 0;
#endif // USE_LINKED_LIST y/n

static void add2list( char * pb )
{
   size_t len = strlen(pb);
   if(len) {
#ifdef USE_LINKED_LIST
      size_t sz = sizeof(MYLINES) + (len * sizeof(TCHAR));
      PLE pn = (PLE)new BYTE[sz];
      if(pn) {
         PMYLINES pml = (PMYLINES)pn;
         char * cp = &pml->line[0];
         strcpy(cp,pb);
         InsertTailList(&sLineList,pn);
      }
#else // !USE_LINKED_LIST
      if((BufLen + len) < 1024) {
         strcat( szDllBuf, pb );
         BufLen = strlen(szDllBuf);
#endif // USE_LINKED_LIST
   }
}

static int _cdecl sprtflist( char * pf, ... )
{
   static char _s_sprtflbuf[1024];
   char * pb = _s_sprtflbuf;
   int   i;
   va_list arglist;
   va_start(arglist, pf);
   i = vsprintf( pb, pf, arglist );
   va_end(arglist);
   add2list(pb);
   return i;
}


#define  SHOWMEM1(a) sprtf( "%s(%d): using " a , __FILE__, __LINE__ + 1 )
#define  SHOWMEM2(a,b) sprintf((char *)a, "%p %s", a, b); sprtf( " %s\n", a)

VOID mt_Allocate_using_new(VOID)
{
   SHOWMEM1( "new BYTE[1234] " );
   pmtVoid1 = new BYTE[1234];
   SHOWMEM2(pmtVoid1, "new");
}
VOID mt_Allocate_using_malloc(VOID)
{
   SHOWMEM1( "malloc 4567 " );
   pmtVoid2 = malloc(4567);
   SHOWMEM2(pmtVoid2, "malloc");
}

VOID mt_Allocate_using_LocalAlloc(VOID)
{
   SHOWMEM1( "LocalAlloc 2345 " );
   pmtVoid3 = LocalAlloc( LPTR, 2345 );
   SHOWMEM2(pmtVoid3, "LocalAlloc");
}
VOID mt_Allocate_using_VirtualAlloc(VOID)
{
   SHOWMEM1( "VirtualAlloc 3 MB " );
   pmtVoid4 = VirtualAlloc( NULL, 3 * 1024, MEM_COMMIT, PAGE_READWRITE );
   SHOWMEM2(pmtVoid4, "VirtualAlloc");
}

VOID mt_Allocate_using_GlobalAlloc(VOID)
{
   SHOWMEM1( "GlobalAlloc 3456 " );
   pmtVoid5 = GlobalAlloc( GPTR, 3456 );
   SHOWMEM2(pmtVoid5, "GlobalAlloc");
}

VOID mt_Allocate_Test_Memory( VOID )
{
   sprtf( "Allocations made in DLL module: %s ...\n", __FILE__ );
   mt_Allocate_using_new();
   mt_Allocate_using_malloc();
   mt_Allocate_using_LocalAlloc();
   mt_Allocate_using_GlobalAlloc();
   mt_Allocate_using_VirtualAlloc();
}


// This is an example of an exported function.
#ifdef USE_LINKED_LIST
MEMTEST_API PLE fnMemTestDLL(void)
{
   mt_Allocate_Test_Memory();
	return &sLineList;
}
MEMTEST_API void fnMemTestDLLClear(void)
{
   KillLList(&sLineList);
}
#else // !USE_LINKED_LIST
MEMTEST_API char * fnMemTestDLL(void)
{
   mt_Allocate_Test_Memory();
	return &szDllBuf[0];
}
#endif // USE_LINKED_LIST y/n

// This is the constructor of a class that has been exported.
// see mtDLL.h for the class definition
CMemtest::CMemtest()
{ 
	return; 
}

